︠0884a56b-ffa4-427f-b86f-63d233371628︠
# Question 1
# Example 1: Creating a relation as a set of ordered pairs
relation1 = {(1, 2), (2, 3), (3, 4),(1,3)}
relation = {(a,b) for a in range(1,4) for b in range (1,4) if a<=b}

print(relation1)
print(relation)

︡b01e10ab-aa2f-485d-bbe8-09a1577e86f8︡{"stdout":"{(2, 3), (1, 2), (1, 3), (3, 4)}\n"}︡{"stdout":"{(1, 2), (1, 1), (2, 3), (3, 3), (2, 2), (1, 3)}\n"}︡{"done":true}
︠7447fd8e-09e2-4b9a-8882-2d5c5b5322b5s︠
# Q2
def is_reflexive(r,elements):
    return all((a,a) in r for a in elements)
# to check if it is antisymetric
def is_antisymmetric(r):
    return all (a==b or (b,a) not in r for (a,b) in r)
# to check if it is transitive
def is_transitive(r):
    return all((a, c) in r for (a, b) in r for (_, c) in r if b == _)
# to check if it is reflexive
def is_partial_order(r, elements):

    return is_reflexive(r, elements) and is_antisymmetric(r) and is_transitive(r)
r = {(1, 2), (2, 3), (1, 3)}
# Set of elements
elements = {1, 2, 3}
# Check properties
print("Is the relation reflexive?", is_reflexive(r, elements))
print("Is the relation antisymmetric?", is_antisymmetric(r))
print("Is the relation transitive?", is_transitive(r))
print("Is the relation a partial order?", is_partial_order(r, elements))
︡fae37c08-9130-4445-984a-7df157821bde︡{"stdout":"Is the relation reflexive? False\n"}︡{"stdout":"Is the relation antisymmetric? True\n"}︡{"stdout":"Is the relation transitive? True\n"}︡{"stdout":"Is the relation a partial order? False\n"}︡{"done":true}
︠212ea652-fdfd-4a92-b606-6f4ed6929fe9s︠




#Q3
p=Poset((divisors(24), attrcall("divides")), linear_extension=True)
p.cover_relations()
p.maximal_elements()
p.minimal_elements()
p.show()
︡720d52c2-b971-4d52-8895-548c9814fe8a︡{"stdout":"[[1, 2], [1, 3], [2, 4], [2, 6], [3, 6], [4, 8], [4, 12], [6, 12], [8, 24], [12, 24]]\n"}︡{"stdout":"[24]\n"}︡{"stdout":"[1]\n"}︡{"file":{"filename":"/tmp/tmpblxokgz6/tmp_3emrvchs.svg","show":true,"text":null,"uuid":"7fa596fd-2f7d-4847-a0be-8183fb89649c"},"once":false}︡{"done":true}
︠b64aa49e-0fac-495b-b77f-2a3e77008ba1s︠









 #Q4
P1=Poset((divisors(12),attrcall("divides")),linear_extension=True)
P1.show()
S1=Poset((divisors(6),attrcall("divides")),linear_extension=True)
S1.show()
#upperBound   &   LowerBound
def is_upper_bound(element,S):
    return all(s <= element for s in S)
def is_lower_bound(element,S):
   return all(element <= s for s in S)
is_lower_bound(1,P1)
is_upper_bound(12,P1)
upper_bounds = [u for u in P1 if is_upper_bound(u,S1)]
lower_bounds = [l for l in P1 if is_lower_bound(l,S1)]
lower_bounds
upper_bounds
LUB = min(upper_bounds) if upper_bounds else None
GLB = max(lower_bounds) if lower_bounds else None
LUB
GLB
︡7e22e7ee-085d-4555-bf3b-92a9b0ba6819︡{"file":{"filename":"/tmp/tmpblxokgz6/tmp_8h5ffffa.svg","show":true,"text":null,"uuid":"8d4331c4-bd3e-47c0-a50d-11b2714c0caa"},"once":false}︡{"file":{"filename":"/tmp/tmpblxokgz6/tmp_218z15pu.svg","show":true,"text":null,"uuid":"3fed3f4e-f555-4dff-a5a0-a8ea19814078"},"once":false}︡{"stdout":"True\n"}︡{"stdout":"True\n"}︡{"stdout":"[1]\n"}︡{"stdout":"[6, 12]\n"}︡{"stdout":"6\n"}︡{"stdout":"1\n"}︡{"done":true}
︠03d71314-bcfa-4069-8c12-144506d21eaes︠









#Q5
A1=Poset((divisors(24),attrcall("divides")),linear_extension=True)
A1.show()
A1.is_lattice()
︡b1671c2c-4546-4081-85ec-22e4338e8dfc︡{"file":{"filename":"/tmp/tmpblxokgz6/tmp_1iixaovm.svg","show":true,"text":null,"uuid":"8dcc7976-65f8-4464-b4dd-f665e3725cbd"},"once":false}︡{"stdout":"True\n"}︡{"done":true}
︠0e7f1c55-ff57-4481-9281-2a420d4baa43︠











A=Poset({0:[1,2],2:[3,4]})
A.show()
A.is_lattice()
︡db96bcdb-3760-4a9d-9254-293e9617fd67︡{"file":{"filename":"/tmp/tmpblxokgz6/tmp_n4kf6mgx.svg","show":true,"text":null,"uuid":"7a0f389b-623e-4343-9fae-572721efe800"},"once":false}︡{"stdout":"False\n"}︡{"done":true}









